{* pcxlib.PAS                                                               *}
{* Copyright (c) Genus Microprogramming, Inc. 1988-89  All Rights Reserved. *}

{****************************************************************************

  This file contains the MS Pascal 4.0 interface to the PCX Programmer's
  Toolkit.



  Microsoft Pascal 4.0                    Programmer: Chris Howard 12/10/89

*****************************************************************************}

interface;

unit pcxlib(pcxTEXT,
            pcxGRAPHICS,

            pcxMINDISP,
            pcxCGA_4,
            pcxCGA_6,
            pcxEGA_D,
            pcxEGA_E,
            pcxEGA_F,
            pcxEGA_10,
            pcxVGA_11,
            pcxVGA_12,
            pcxVGA_13,
            pcxHERC,
            pcxXGA_29,
            pcxXGA_2D,
            pcxXGA_2E,
            pcxXGA_30,
            pcxXGA_58,
            pcxXGA_59,
            pcxXGA_5E,
            pcxXGA_5F,
            pcxXGA_62,
            pcxXGA_66,
            pcxXGA_67,
            pcxXGA_69,
            pcxMAXDISP,

            pcxLPT1,
            pcxLPT2,
            pcxLPT3,

            pcxMINPRINT,
            pcxLASER,
            pcxDOTMAT,
            pcxMAXPRINT,

            pcxDRAFT,
            pcxQUALITY,

            pcxSCALE100,
            pcxSCALE75,
            pcxSCALE50,
            pcxSCALE25,
            pcxSCALE200,

            pcxNORESET,
            pcxRESET,
            pcxNOEJECT,
            pcxEJECT,

            pcxFIRST,
            pcxNEXT,

            pcxSET,
            pcxAND,
            pcxOR,
            pcxXOR,

            pcxEMM,
            pcxCMM,

            pcxTRUE,
            pcxFALSE,
            pcxSYNC,

            viNONE,
            viMDA,
            viCGA,
            viEGA,
            viMCGA,
            viVGA,
            viHGC,
            viHGCPlus,
            viHGCColor,

            viMDAdisp,
            viCGAdisp,
            viEGAdisp,
            viVGAmono,
            viVGAcolor,

            chipUNKNOWN,
            chipTSENG,
            chipPARA,
            chipV7,

            pcxHERCdiag,
            pcxHERChalf,
            pcxHERCfull,

            pcxSUCCESS,
            pcxERR_OPEN,
            pcxERR_BUFSMALL,
            pcxERR_READ,
            pcxERR_WRITE,
            pcxERR_NOTPCX,
            pcxERR_BADDISP,
            pcxERR_BADMODE,
            pcxERR_BADPAGE,
            pcxERR_BADPAL,
            pcxERR_NOPAL,
            pcxERR_NOPALGRAB,
            pcxERR_NOTPCXLIB,
            pcxERR_NOSYNC,
            pcxERR_NOTINLIB,
            pcxERR_CLIPPARM,
            pcxERR_NOTIMPL,
            pcxERR_GENERAL,

            pcxERR_BADPRINT,
            pcxERR_BADPORT,
            pcxERR_PRINTER,
            pcxERR_NOTBW,
            pcxERR_ESCAPE,
            pcxERR_NOEMM,
            pcxERR_EMMFAIL,
            pcxERR_EMMNOMEM,
            pcxERR_BADMEMTYPE,
            pcxERR_CMMFAIL,
            pcxERR_CMMNOMEM,

            PCXHEADER,

            PCXLIBHEADER,

            PCXLIBDIR,

            PCXDINFO,

            PCXVINFO,

            pcxFileBuffer,
            pcxBufferFile,
            pcxSetDisplay,
            pcxGetDisplay,
            pcxSetMode,
            pcxSetBuffer,
            pcxGetDispStruc,
            pcxGetVersion,
            pcxGetDisplayInfo,
            pcxSetHerc,
            pcxModeCHeck,
            pcxBufferDisplay,
            pcxDisplayBuffer,
            pcxLibBuffer,
            pcxLibSearch,
            pcxFileDisplay,
            pcxLibDisplay,
            pcxDisplayFile,
            pcxSetPage,
            pcxGetPage,
            pcxVerifyBuffer,
            pcxGetBufferHeader,
            pcxSetBufferHeader,
            pcxGetBufferType,
            pcxVerifyFile,
            pcxGetFileHeader,
            pcxSetFileHeader,
            pcxGetFileType,
            pcxGetLibHeader,
            pcxGetLibType,
            pcxDecodePalette,
            pcxEncodePalette,
            pcxSetDisplayPalette,
            pcxGetDisplayPalette,
            pcxSetBufferPalette,
            pcxGetBufferPalette,
            pcxSetFilePalette,
            pcxGetFilePalette,
            pcxGetLibPalette,
            pcxBeginPaletteGrab,
            pcxEndPaletteGrab,

            pcxTextBuffer,
            pcxBufferText,
            pcxVideoInfo,
            pcxQueryChipset,
            pcxSetPrinter,
            pcxBufferPrint,
            pcxFilePrint,
            pcxLibPrint,
            pcxVirtualPrint,
            pcxDisplayPrint,
            pcxEMInstalled,
            pcxVirtualSize,
            pcxVirtualFree,
            pcxCreateVirtual,
            pcxDestroyVirtual,
            pcxBufferVirtual,
            pcxFileVirtual,
            pcxLibVirtual,
            pcxVirtualDisplay,
            pcxVirtualScroll,
            pcxPutImage,
            pcxGetImage

            );

const

  { PCX Display modes }
  pcxTEXT          = 0;                     { Text mode                   }
  pcxGRAPHICS      = 1;                     { Graphics mode               }

  { PCX Display types }
  pcxMINDISP       = 0;
  pcxCGA_4         = 0;                     { CGA Mode  4H (320x200x4)    }
  pcxCGA_6         = 1;                     { CGA Mode  5H (640x200x2)    }
  pcxEGA_D         = 2;                     { EGA Mode  DH (320x200x16)   }
  pcxEGA_E         = 3;                     { EGA Mode  EH (640x200x16)   }
  pcxEGA_F         = 4;                     { EGA Mode  FH (640x350x2)    }
  pcxEGA_10        = 5;                     { EGA Mode 10H (640x350x16)   }
  pcxVGA_11        = 6;                     { VGA Mode 11H (640x480x2)    }
  pcxVGA_12        = 7;                     { VGA Mode 12H (640x480x16)   }
  pcxVGA_13        = 8;                     { VGA Mode 13H (320x200x256)  }
  pcxHERC          = 9;                     { Hercules     (720x348x2)    }
  pcxXGA_29        = 10;                    { Tseng    29H (800x600x16)   }
  pcxXGA_2D        = 11;                    { Tseng    2DH (640x350x256)  }
  pcxXGA_2E        = 12;                    { Tseng    2EH (640x480x256)  }
  pcxXGA_30        = 13;                    { Tseng    30H (800x600x256)  }
  pcxXGA_58        = 14;                    { Paradise 58H (800x600x16)   }
  pcxXGA_59        = 15;                    { Paradise 59H (800x600x2)    }
  pcxXGA_5E        = 16;                    { Paradise 5EH (640x400x256)  }
  pcxXGA_5F        = 17;                    { Paradise 5FH (640x480x256)  }
  pcxXGA_62        = 18;                    { Video 7  62H (800x600x16)   }
  pcxXGA_66        = 19;                    { Video 7  66H (640x400x256)  }
  pcxXGA_67        = 20;                    { Video 7  67H (640x480x256)  }
  pcxXGA_69        = 21;                    { Video 7  69H (800x600x256)  }
  pcxMAXDISP       = 21;

  pcxLPT1          = 0;                     { Printer port 1              }
  pcxLPT2          = 1;                     { Printer port 2              }
  pcxLPT3          = 2;                     { Printer port 3              }

  pcxMINPRINT      = 0;                     { Minimum printer type        }
  pcxLASER         = 0;                     { HP LaserJet                 }
  pcxDOTMAT        = 1;                     { Dot Matrix                  }
  pcxMAXPRINT      = 1;                     { Maximum printer type        }

  pcxDRAFT         = 0;                     { Draft mode                  }
  pcxQUALITY       = 1;                     { Quality                     }

  pcxSCALE100      = 0;                     { 100%                        }
  pcxSCALE75       = 1;                     {  75%                        }
  pcxSCALE50       = 2;                     {  50%                        }
  pcxSCALE25       = 3;                     {  25%                        }
  pcxSCALE200      = 4;                     { 200%                        }

  pcxNORESET       = 0;                     { No reset before printing    }
  pcxRESET         = 1;                     { Reset before printing       }
  pcxNOEJECT       = 0;                     { No eject after printing     }
  pcxEJECT         = 1;                     { Eject page after printing   }

  pcxFIRST         = 0;                     { Find first matching entry   }
  pcxNEXT          = 1;                     { Find next matching entry    }

  pcxSET           = 0;                     { SET pixel value directly    }
  pcxAND           = 1;                     { AND pixel value with data   }
  pcxOR            = 2;                     { OR  pixel value with data   }
  pcxXOR           = 3;                     { XOR pixel value with data   }

  pcxEMM           = 0;                     { Expanded Memory virtual     }
  pcxCMM           = 1;                     { Conventional Memory virtual }

  pcxTRUE          = 1;                     { True value                  }
  pcxFALSE         = 0;                     { False value                 }
  pcxSYNC          = 1;                     { PCX library synch value     }

  viNONE           = 0;                     { No adapter/display          }
  viMDA            = 1;                     { Monochrome Display Adapter  }
  viCGA            = 2;                     { Color Graphics Adapter      }
  viEGA            = 3;                     { Enhanced Graphics Adapter   }
  viMCGA           = 4;                     { MCGA                        }
  viVGA            = 5;                     { Video Graphics Array        }
  viHGC            = #80;                   { Hercules Monochrome         }
  viHGCPlus        = #81;                   { Hercules Plus               }
  viHGCColor       = #82;                   { Hercules InColor            }

  viMDAdisp        = 1;                     { Monochrome Display          }
  viCGAdisp        = 2;                     { CGA Display                 }
  viEGAdisp        = 3;                     { EGA Display                 }
  viVGAmono        = 4;                     { VGA Monochrome Display      }
  viVGAcolor       = 5;                     { VGA Color Display           }

  chipUNKNOWN      = 0;                     { Unknown chip set            }
  chipTSENG        = 1;                     { Tseng Labs                  }
  chipPARA         = 2;                     { Paradise                    }
  chipV7           = 3;                     { Video 7                     }

  pcxHERCdiag      = 0;                     { Hercules Diagnostic         }
  pcxHERChalf      = 1;                     { Hercules Half               }
  pcxHERCfull      = 3;                     { Hercules Full               }

  { Error Codes }
  pcxSUCCESS       = 0;                     { Successful                  }
  pcxERR_OPEN      = -1;                    { Error opening file          }
  pcxERR_BUFSMALL  = -2;                    { Buffer is too small         }
  pcxERR_READ      = -3;                    { Error in reading from file  }
  pcxERR_WRITE     = -4;                    { Error in writing to file    }
  pcxERR_NOTPCX    = -5;                    { Not a valid pcx buffer/file }
  pcxERR_BADDISP   = -6;                    { Display not defined/invalid }
  pcxERR_BADMODE   = -7;                    { Bad display mode            }
  pcxERR_BADPAGE   = -8;                    { Bad page                    }
  pcxERR_BADPAL    = -9;                    { Bad palette                 }
  pcxERR_NOPAL     = -10;                   { No palette available        }
  pcxERR_NOPALGRAB = -11;                   { Palette is not grabbed      }
  pcxERR_NOTPCXLIB = -12;                   { Not a PCX library           }
  pcxERR_NOSYNC    = -13;                   { Lost image synch in library }
  pcxERR_NOTINLIB  = -14;                   { Image not found in library  }
  pcxERR_CLIPPARM  = -15;                   { Bad number of Clipper parms }
  pcxERR_NOTIMPL   = -900;                  { Not implemented yet         }
  pcxERR_GENERAL   = -999;                  { General error               }

  pcxERR_BADPRINT  = -16;                   { Bad printer type            }
  pcxERR_BADPORT   = -17;                   { Bad printer port            }
  pcxERR_PRINTER   = -18;                   { Pr err (timeout,i/o,paper)  }
  pcxERR_NOTBW     = -19;                   { Not a Black/White image     }
  pcxERR_ESCAPE    = -20;                   { Escape key was pressed      }
  pcxERR_NOEMM     = -21;                   { No EMM driver was found     }
  pcxERR_EMMFAIL   = -22;                   { General EMM driver failure  }
  pcxERR_EMMNOMEM  = -23;                   { No EMM memory available     }
  pcxERR_BADMEMTYPE= -24;                   { Bad virtual memory type     }
  pcxERR_CMMFAIL   = -25;                   { General CMM alloc/free err  }
  pcxERR_CMMNOMEM  = -26;                   { No CMM memory available     }

type
  { PCX Header structure }
  PCXHEADER        = record
    manuf          : byte;                  { Always =10 for Paintbrush   }
    hard           : byte;                  { Version information         }
    encod          : byte;                  { Run-length encoding (=1)    }
    bitpx          : byte;                  { Bits per pixel              }
    x1             : word;                  { Picture dimensions (incl)   }
    y1             : word;                  {                             }
    x2             : word;                  {                             }
    y2             : word;                  {                             }
    hres           : word;                  { Display horiz resolution    }
    vres           : word;                  { Display vert  resolution    }
    clrma          : array[0..47] of byte;  { Pallete                     }
    vmode          : byte;                  { (ignored)                   }
    nplanes        : byte;                  { Number of planes (ver 2.5=0)}
    bplin          : word;                  { Bytes per line              }
    palinfo        : word;                  { Palette Info (1=col, 2=gray)}
    shres          : word;                  { Scanner resolution          }
    svres          : word;                  {                             }
    xtra           : array[0..54] of byte;  { Extra space (filler)        }
  end;

  { Image Library Header }
  PCXLIBHEADER     = record
    id             : array[0..9] of byte;   { Library ID string           }
    copyright      : array[0..49] of byte;  { Copyright notice            }
    version        : word;                  { pcxLib version              }
    vollabel       : array[0..39] of char;  { Library volume label        }
    xtra           : array[0..19] of byte;  { filler                      }
  end;

  { Image Library Image Header }
  PCXLIBDIR        = record
    synch          : byte;                  { Synch byte                  }
    filename       : array[0..12] of char;  { Image file name             }
    filesize       : integer4;              { File size                   }
    date           : word;                  { File date                   }
    time           : word;                  { File time                   }
    pack           : word;                  { Packing type                }
    note           : array[0..39] of char;  { Image note                  }
    xtra           : array[0..20] of byte;  { Extra filler                }
  end;

  { PCX Toolkit display type information }
  PCXDINFO         = record
    dtype          : byte;                  { Display type                }
    descrip        : array[0..12] of char;  { String description          }
    mode           : byte;                  { Actual BIOS mode            }
    bitpx          : byte;                  { Number of bits per pixel    }
    hres           : word;                  { Horizontal resolution       }
    vres           : word;                  { Vertical   resolution       }
    planes         : byte;                  { Number of display planes    }
    pages          : byte;                  { Number of display pages     }
    begseg         : word;                  { Beginning display segment   }
    pagesize       : word;                  { Size of display page        }
    paltype        : word;                  { Palette format type         }
    dispfunc       : integer4;              { Address of display function }
    bufffunc       : integer4;              { Address of buffer  function }
    virtfunc       : integer4;              { Address of virtual function }
    putfunc        : integer4;              { Address of put     function }
    getfunc        : integer4;              { Address of get     function }
  end;

  { Video Info structure }
  PCXVINFO         = record
    adapter        : byte;                  { Video Adapter               }
    display        : byte;                  { Video Display               }
  end;


{pcxFB.asm}
function   pcxFileBuffer        (filename:adsmem;bufptr:adsmem;bufmax:word):word;

{pcxBF.asm}
function   pcxBufferFile        (bufptr:adsmem;bufsize:word;filename:adsmem):integer;

{pcxSD.asm}
function   pcxSetDisplay        (disptype:integer):integer;
function   pcxGetDisplay        :integer;
function   pcxSetMode           (dispmode:integer):integer;
function   pcxSetBuffer         (bufptr:adsmem;bufmax:word):integer;
function   pcxGetDispStruc      (disptype:integer):adsmem;

function   pcxGetVersion        (verbuf:adsmem):integer;
function   pcxGetDisplayInfo    (disptype:integer;di:adsmem):integer;
function   pcxSetHerc           (hercflag:integer):integer;
function   pcxModeCheck         (modeflag:integer):integer;

{pcxBD.asm}
function   pcxBufferDisplay     (bufptr:adsmem;bufsize:word;x,y,page:integer):integer;

{pcxDB.asm}
function   pcxDisplayBuffer     (bufptr:adsmem;bufmax:word;x1,y1,x2,y2,page:integer):integer;

{pcxLB.asm}
function   pcxLibBuffer         (libname:adsmem;filename:adsmem;bufptr:adsmem;bufmax:word):word;
function   pcxLibSearch         (libname:adsmem;filemask:adsmem;libdir:adsmem;sflag:integer):integer;

{pcxFD.asm}
function   pcxFileDisplay       (filename:adsmem;x,y,page:integer):integer;

{pcxLD.asm}
function   pcxLibDisplay        (libname:adsmem;filename:adsmem;x,y,page:integer):integer;

{pcxDF.asm}
function   pcxDisplayFile       (filename:adsmem;x1,y1,x2,y2,page:integer):integer;

{pcxSP.asm}
function   pcxSetPage           (page:integer):integer;
function   pcxGetPage           :integer;

{pcxBH.asm}
function   pcxVerifyBuffer      (bufptr:adsmem):integer;
function   pcxGetBufferHeader   (bufptr:adsmem;VARS headptr:PCXHEADER):integer;
function   pcxSetBufferHeader   (bufptr:adsmem;VARS headptr:PCXHEADER):integer;
function   pcxGetBufferType     (bufptr:adsmem):integer;

{pcxFH.asm}
function   pcxVerifyFile        (filename:adsmem):integer;
function   pcxGetFileHeader     (filename:adsmem;VARS headptr:PCXHEADER):integer;
function   pcxSetFileHeader     (filename:adsmem;VARS headptr:PCXHEADER):integer;
function   pcxGetFileType       (filename:adsmem):integer;

{pcxLH.asm}
function   pcxGetLibHeader      (libname:adsmem;filename:adsmem;VARS headptr:PCXHEADER):integer;
function   pcxGetLibType        (libname:adsmem;filename:adsmem):integer;

{pcxDP.asm}
function   pcxDecodePalette     (disptype:integer;clrptr:adsmem;palptr:adsmem):integer;
function   pcxEncodePalette     (disptype:integer;clrptr:adsmem;palptr:adsmem):integer;
function   pcxSetDisplayPalette (palptr:adsmem):integer;
function   pcxGetDisplayPalette (palptr:adsmem):integer;
function   pcxSetBufferPalette  (disptype:integer;bufptr:adsmem;bufsize:word;palptr:adsmem):integer;
function   pcxGetBufferPalette  (disptype:integer;bufptr:adsmem;bufsize:word;palptr:adsmem):integer;
function   pcxSetFilePalette    (disptype:integer;filename:adsmem;palptr:adsmem):integer;
function   pcxGetFilePalette    (disptype:integer;filename:adsmem;palptr:adsmem):integer;
function   pcxGetLibPalette     (disptype:integer;libname:adsmem;filename:adsmem;palptr:adsmem):integer;

{pcxPG.asm}
function   pcxBeginPaletteGrab  (palptr:adsmem):integer;
function   pcxEndPaletteGrab    :integer;

{ New 3.5 functions }

{pcxTB.asm}
function   pcxTextBuffer        (textbuf:adsmem):integer;
function   pcxBufferText        (textbuf:adsmem):integer;

{pcxVI.asm}
function   pcxVideoInfo         (vi:adsmem):integer;
function   pcxQueryChipset      :integer;

{pcxBP.asm}
function   pcxSetPrinter        (pport,device,mode,scale,reset,eject:integer):integer;
function   pcxBufferPrint       (bufptr:adsmem;bufsize,x,y:integer):integer;

{pcxFP.asm}
function   pcxFilePrint         (filename:adsmem;x,y:integer):integer;

{pcxLP.asm}
function   pcxLibPrint          (libname:adsmem;filename:adsmem;x,y:integer):integer;

{pcxVP.asm}
function   pcxVirtualPrint      (vptr:integer4;x,y:integer):integer;

{pcxYP.asm}
function   pcxDisplayPrint      (x,y:integer):integer;

{pcxEM.asm}
function   pcxEMInstalled       :integer;
function   pcxVirtualSize       (disptype,width,depth:integer):integer4;
function   pcxVirtualFree       (vtype:integer):integer4;
function   pcxCreateVirtual     (vtype:integer;vptr:adsmem;disptype,width,depth:integer):integer;
function   pcxDestroyVirtual    (vptr:integer4):integer;

{pcxBV.asm}
function   pcxBufferVirtual     (bufptr:adsmem;bufsize:integer;vptr:integer4):integer;

{pcxFV.asm}
function   pcxFileVirtual       (filename:adsmem;vptr:integer4):integer;

{pcxLV.asm}
function   pcxLibVirtual        (libname:adsmem;filename:adsmem;vptr:integer4):integer;

{pcxVD.asm}
function   pcxVirtualDisplay    (vptr:integer4;vx,vy,x1,y1,x2,y2,page:integer):integer;

{pcxVS.asm}
function   pcxVirtualScroll     (vptr:integer4;width,depth,x1,y1,x2,y2,page:integer):integer;

{pcxPI.asm}
function   pcxPutImage          (vptr:integer4;op,x,y,page:integer):integer;

{pcxGI.asm}
function   pcxGetImage          (vptr:integer4;x1,y1,x2,y2,page:integer):integer;

end;


