{* pcxTest.PAS                                                              *}
{* Copyright (c) Genus Microprogramming, Inc. 1988-89  All Rights Reserved. *}

{****************************************************************************

  This program merely enters graphics mode, sets the palette, and displays
  the test image "pcxTest.PCX".  It is an example Pascal routine for the PCX
  Programmer's Toolkit.

  NOTE: REQUIRES A CGA (or compatible) ADAPTER AND DISPLAY!

  To Compile: Turbo Pascal 4.x   turbo pcxtest
                                 (press "Alt-R" to run)
                            or   tpc   pcxtest

  Borland Turbo Pascal 4.0/5.0            Programmer: Chris Howard  2/01/89

*****************************************************************************}

Program pcxTest;

{ Include the PCX Toolkit Unit, and any other units needed }
uses pcx_tp,crt;

{ Globals }
const
  pcxtype        = pcxCGA_4;
  pcximage       = 'pcxTest.PCX';

  bufmax         = 20000;

var
  pcxpal         : array[1..800] of byte;
  retcode        : integer;
  key            : char;

  buffer         : array[1..bufmax] of byte;

{**********}

begin

  { Display program header }
  writeln;
  writeln('͸');
  writeln(' pcxTest: Example Pascal Test Program       PCX Programmer''s Toolkit 3.50 ');
  writeln(' Copyright (c) Genus Microprogramming, Inc. 1988-89  All Rights Reserved. ');
  writeln(';');
  writeln;

  { Get a key, to begin }
  writeln('Press a key to run . . .');
  key := ReadKey;

  { Allocate a larger toolkit buffer, to speed up file and display speed. } 
  { The toolkit defaults to using an internal 2KB buffer, but if we can   } 
  { spare more memory than that, declare a new buffer.                    } 
  { REMEMBER: This MUST be a GLOBAL buffer (ie, declare OUTSIDE of procs) } 

  retcode := pcxSetBuffer(@buffer,bufmax);

  { Set the display type and mode we will be using }
  retcode := pcxSetDisplay(pcxtype);
  if (retcode = pcxSUCCESS) then begin

    { Now enter graphics mode }
    retcode := pcxSetMode(pcxGRAPHICS);
    if (retcode = pcxSUCCESS) then begin

      { We are in graphics mode, so set the image file palette            }
      { NOTE: If all your images use a default BIOS palette (or the       }
      {       default Paintbrush palette), just SKIP setting the palette! }

      retcode := pcxGetFilePalette(pcxtype,pcximage,addr(pcxpal));
      if (retcode = pcxSUCCESS) then begin
        { Now set it }
        retcode := pcxSetDisplayPalette(addr(pcxpal));
        if (retcode <> pcxSUCCESS) then begin
          { Error setting palette }
          writeln('pcxSetDisplayPalette error: ',retcode);
        end;
      end
      else begin
        { Error getting the palette }
        writeln('pcxGetFilePalette error: ',retcode);
      end;

      { Now display the image file }
      retcode := pcxFileDisplay(pcximage,0,0,0);
      if (retcode <> pcxSUCCESS) then begin
        { Error displaying the file }
        writeln('pcxFileDisplay error: ',retcode);
      end;

      { Wait for a key }
      key := ReadKey;

      { Return to text mode }
      retcode := pcxSetMode(pcxTEXT);

    end
    else begin
      { Error setting the mode }
      writeln('pcxSetMode error: ',retcode);
    end;

  end
  else begin
    { Error setting the display type }
    writeln('pcxSetDisplay error: ',retcode);
  end;

end. { end of main }

